Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_transition.cpp	(revision 138)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_transition.cpp	(revision 139)
@@ -54,8 +54,9 @@
 //            reg_EVENT_FLUSH           [i][j] = false;
 //            reg_EVENT_STOP            [i][j] = false;
-              reg_EVENT_NUM_BANK        [i][j] = 0; // not necessary
-              reg_EVENT_NUM_PTR         [i][j] = 0; // not necessary
-            //reg_EVENT_CAN_RESTART     [i][j] = 0; // not necessary
+//            reg_EVENT_NUM_BANK        [i][j] = 0; // not necessary
+//            reg_EVENT_NUM_PTR         [i][j] = 0; // not necessary
+//            reg_EVENT_CAN_RESTART     [i][j] = 0; // not necessary
               reg_EVENT_PACKET          [i][j] = 0; // not necessary
+              reg_EVENT_DEPTH           [i][j] = 0; // not necessary
               reg_EVENT_NB_INST         [i][j] = 0;
               reg_EVENT_LAST            [i][j] = false;
@@ -72,4 +73,14 @@
               reg_PC_NEXT               [i][j] = (0x100+4)>>2;
 	    }
+
+        // Resert RAT_UPDATE_TABLE
+	for (uint32_t i=0; i<_param->_nb_front_end; i++)
+	  for (uint32_t j=0; j<_param->_nb_context[i]; j++)
+	    {
+	      for (uint32_t k=0; k<_param->_nb_general_register_logic; k++)
+                rat_gpr_update_table       [i][j][k] = false; // not necessary
+	      for (uint32_t k=0; k<_param->_nb_special_register_logic; k++)
+                rat_spr_update_table       [i][j][k] = false; // not necessary
+            }
 
         // Reset priority algorithm
@@ -114,4 +125,10 @@
 //                         else
                           reg_EVENT_STATE [i][j] = COMMIT_EVENT_STATE_WAIT_END; 
+                          
+                          // Reset update_table
+                          for (uint32_t k=0; k<_param->_nb_general_register_logic; k++)
+                            rat_gpr_update_table      [i][j][k] = false;
+                          for (uint32_t k=0; k<_param->_nb_special_register_logic; k++)
+                            rat_spr_update_table      [i][j][k] = false;
                       }
                     
@@ -180,8 +197,11 @@
                         else
                           {
+                            uint32_t next_packet = reg_EVENT_NEXT_PACKET [i][j];
+
                             reg_EVENT_STATE         [i][j] = COMMIT_EVENT_STATE_NOT_YET_EVENT;
 
                             reg_EVENT_NEXT_STOP     [i][j] = false;
-                            reg_EVENT_PACKET        [i][j] = reg_EVENT_NEXT_PACKET [i][j];
+                            reg_EVENT_PACKET        [i][j] = next_packet;
+//                          reg_EVENT_DEPTH         [i][j] = _rob[next_packet].depth;
                             reg_EVENT_NB_INST       [i][j] = reg_NB_INST_COMMIT_ALL [i][j];
                           //reg_EVENT_STOP          [i][j] = true;
@@ -596,4 +616,5 @@
                                 reg_EVENT_STATE         [front_end_id][context_id] = COMMIT_EVENT_STATE_NOT_YET_EVENT;
 
+//                              reg_EVENT_DEPTH         [front_end_id][context_id] = _rob[packet].depth;
                                 reg_EVENT_NB_INST       [front_end_id][context_id] = reg_NB_INST_COMMIT_ALL [front_end_id][context_id];
 
@@ -697,9 +718,7 @@
 #endif
 
-
 #ifdef STATISTICS
-	    if (usage_is_set(_usage,USE_STATISTICS))
-	      (*_stat_nb_inst_retire [x]) ++;
-                
+                if (usage_is_set(_usage,USE_STATISTICS))
+                  (*_stat_nb_inst_retire [x]) ++;
 #endif
                 
@@ -709,4 +728,14 @@
                 entry->state_old = entry->state;
                 entry->state     = ROB_END;
+
+
+                // Update RAT_UPDATE_TABLE
+                Tcontext_t front_end_id = entry->front_end_id;
+                Tcontext_t context_id   = entry->context_id  ;
+
+                if (entry->write_rd and internal_BANK_RETIRE_RESTORE_RD_PHY_OLD [num_bank])
+                  rat_gpr_update_table [front_end_id][context_id][entry->num_reg_rd_log] = true;
+                if (entry->write_re and internal_BANK_RETIRE_RESTORE_RE_PHY_OLD [num_bank])
+                  rat_spr_update_table [front_end_id][context_id][entry->num_reg_re_log] = true;
               }
           }
@@ -771,9 +800,11 @@
 	              {
                           reg_EVENT_STATE         [front_end_id][context_id] = COMMIT_EVENT_STATE_EVENT;
+                          reg_EVENT_TYPE          [front_end_id][context_id] = rob_state_to_event_type(state);
 //                        reg_EVENT_STOP          [front_end_id][context_id] = false; // instruction flow can continue
                           reg_EVENT_LAST          [front_end_id][context_id] = false;
                           // it the head !
                           reg_EVENT_PACKET        [front_end_id][context_id] = packet_id;
-	            
+                          reg_EVENT_DEPTH         [front_end_id][context_id] = entry->depth;
+
 //                           // If event is an load_miss, many instruction can be inserted. 
 //                           // -> new last instruction
@@ -947,6 +978,6 @@
                       // In all case, stop instruction flow
                       reg_EVENT_STATE         [entry->front_end_id][entry->context_id] = COMMIT_EVENT_STATE_NOT_YET_EVENT;
+//                    reg_EVENT_DEPTH         [entry->front_end_id][entry->context_id] = _rob[packet]._depth;
                       reg_EVENT_NB_INST       [entry->front_end_id][entry->context_id] = reg_NB_INST_COMMIT_ALL [entry->front_end_id][entry->context_id];
-                                
 //                    reg_EVENT_STOP          [entry->front_end_id][entry->context_id] = true;
 
@@ -1283,4 +1314,5 @@
 //          log_printf(TRACE,Commit_unit,FUNCTION,"      * EVENT             : %d (bank %d, ptr %d)",((reg_EVENT_NUM_PTR [i][j] << _param->_shift_num_slot) | reg_EVENT_NUM_BANK [i][j]), reg_EVENT_NUM_BANK [i][j],reg_EVENT_NUM_PTR [i][j]);
 //          log_printf(TRACE,Commit_unit,FUNCTION,"      * EVENT_CAN_RESTART : %d",reg_EVENT_CAN_RESTART [i][j]);
+            log_printf(TRACE,Commit_unit,FUNCTION,"      * EVENT_DEPTH       : %d - type %s",reg_EVENT_DEPTH [i][j],toString(reg_EVENT_TYPE [i][j]).c_str());
             log_printf(TRACE,Commit_unit,FUNCTION,"      * EVENT_LAST        : %d - packet %d - ptr %d (bank %d, ptr %d)",reg_EVENT_LAST [i][j],reg_EVENT_PACKET[i][j],((reg_EVENT_LAST_NUM_PTR [i][j] << _param->_shift_num_slot) | reg_EVENT_LAST_NUM_BANK [i][j]), reg_EVENT_LAST_NUM_BANK [i][j],reg_EVENT_LAST_NUM_PTR [i][j]);
             log_printf(TRACE,Commit_unit,FUNCTION,"      * EVENT_NEXT        : stop : %d - packet : %d",reg_EVENT_NEXT_STOP  [i][j],reg_EVENT_NEXT_PACKET[i][j]);
@@ -1370,4 +1402,25 @@
         }
 
+      log_printf(TRACE,Commit_unit,FUNCTION,"  * Dump RAT Update Table");
+      for (uint32_t i=0; i<_param->_nb_front_end; ++i)
+        for (uint32_t j=0; j<_param->_nb_context[i]; ++j)
+          {
+            {
+              std::string str = "";
+              for (uint32_t k=0; k<_param->_nb_general_register_logic; k++)
+                str+=toString("%.1d ",rat_gpr_update_table[i][j][k]);
+              
+              log_printf(TRACE,Commit_unit,FUNCTION,"    * GPR [%d][%d] %s",i,j,str.c_str());
+            }
+
+            {
+              std::string str = "";
+              for (uint32_t k=0; k<_param->_nb_special_register_logic; k++)
+                str+=toString("%.1d ",rat_spr_update_table[i][j][k]);
+              
+              log_printf(TRACE,Commit_unit,FUNCTION,"    * GPR [%d][%d] %s",i,j,str.c_str());
+            }
+          }
+
       log_printf(TRACE,Commit_unit,FUNCTION,"    * nb_write_rd   : %d",nb_write_rd);
       log_printf(TRACE,Commit_unit,FUNCTION,"    * nb_write_re   : %d",nb_write_re);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Parameters.cpp	(revision 138)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Parameters.cpp	(revision 139)
@@ -22,15 +22,15 @@
 #define FUNCTION "Commit_unit::Parameters"
   Parameters::Parameters (uint32_t             nb_front_end                       ,
-			  uint32_t           * nb_context                         ,
-			  uint32_t             nb_rename_unit                     ,
-			  uint32_t             size_queue                         ,
-			  uint32_t             nb_bank                            ,
-                          Tretire_ooo_scheme_t retire_ooo_scheme                  ,
-			  uint32_t           * nb_inst_insert                     ,
-			  uint32_t           * nb_inst_retire                     ,
-			  uint32_t             nb_inst_commit                     ,
-			  uint32_t             nb_inst_reexecute                  ,
-			  uint32_t             nb_inst_branch_complete            ,
-			  uint32_t          ** nb_branch_speculated               ,
+			  uint32_t           * nb_context                         ,//[nb_front_end]            
+			  uint32_t             nb_rename_unit                     ,                            
+			  uint32_t             size_queue                         ,                            
+			  uint32_t             nb_bank                            ,                            
+                          Tretire_ooo_scheme_t retire_ooo_scheme                  ,                            
+			  uint32_t           * nb_inst_insert                     ,//[nb_rename_unit]          
+			  uint32_t           * nb_inst_retire                     ,//[nb_rename_unit]
+			  uint32_t             nb_inst_commit                     ,                            
+			  uint32_t             nb_inst_reexecute                  ,                            
+			  uint32_t             nb_inst_branch_complete            ,                            
+			  uint32_t          ** nb_branch_speculated               ,//[nb_front_end][nb_context]
                           uint32_t             size_nb_inst_decod                 ,
 			  uint32_t             size_general_data                  ,
@@ -39,9 +39,10 @@
 			  uint32_t             size_general_register              ,
 			  uint32_t             size_special_register              ,
+			  Trat_scheme_t      * rat_scheme                         ,//[nb_front_end]
 			  Tpriority_t          priority                           ,
 			  Tload_balancing_t    load_balancing                     ,
 			  uint32_t             nb_rename_unit_select              ,
                           uint32_t             nb_thread                          ,
-                          uint32_t          ** translate_num_context_to_num_thread,
+                          uint32_t          ** translate_num_context_to_num_thread,//[nb_front_end][nb_context]
                           bool                 is_toplevel):
     _nb_bank_access_commit (1              )
@@ -61,4 +62,5 @@
     _nb_inst_branch_complete             = nb_inst_branch_complete            ;
     _nb_branch_speculated                = nb_branch_speculated               ;
+    _rat_scheme                          = rat_scheme                         ;
     _priority                            = priority                           ;
     _load_balancing                      = load_balancing                     ;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/include/Parameters.h	(revision 138)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/include/Parameters.h	(revision 139)
@@ -11,4 +11,5 @@
 #include "Common/include/Debug.h"
 #include "Behavioural/include/Parameters.h"
+#include "Behavioural/include/Types.h"
 
 namespace morpheo {
@@ -25,27 +26,32 @@
   {
     //-----[ fields ]------------------------------------------------------------
-  public : uint32_t   _nb_front_end          ;
-  public : uint32_t * _nb_context            ;//[nb_front_end]
-  public : uint32_t   _nb_general_register   ;
-  public : uint32_t   _nb_special_register   ;
-  public : uint32_t   _nb_inst_insert        ;
-  public : uint32_t   _nb_inst_retire        ;    
-		      
-//public : uint32_t   _size_front_end_id     ;
-//public : uint32_t   _size_context_id       ;
-//public : uint32_t   _size_general_register ;
-//public : uint32_t   _size_special_register ;
-//      	      
-//public : uint32_t   _have_port_context_id  ;
-//public : uint32_t   _have_port_front_end_id;
+  public : uint32_t         _nb_front_end          ;
+  public : uint32_t       * _nb_context            ;//[nb_front_end]
+  public : uint32_t         _nb_general_register   ;
+  public : uint32_t         _nb_special_register   ;
+  public : Trat_scheme_t    _rat_scheme            ;
+  public : uint32_t         _nb_inst_insert        ;
+  public : uint32_t         _nb_inst_retire        ;    
+  public : uint32_t      ** _nb_branch_speculated  ;//[nb_front_end][nb_context]
+    
+  public : uint32_t         _max_nb_context        ;
+//public : uint32_t         _size_front_end_id     ;
+//public : uint32_t         _size_context_id       ;
+//public : uint32_t         _size_general_register ;
+//public : uint32_t         _size_special_register ;
+//      	            
+//public : uint32_t         _have_port_context_id  ;
+//public : uint32_t         _have_port_front_end_id;
 
     //-----[ methods ]-----------------------------------------------------------
-  public : Parameters  (uint32_t   nb_front_end       ,
-			uint32_t * nb_context         ,
-			uint32_t   nb_general_register,
-			uint32_t   nb_special_register,
-			uint32_t   nb_inst_insert     ,
-			uint32_t   nb_inst_retire     ,
-                        bool       is_toplevel=false
+  public : Parameters  (uint32_t         nb_front_end        ,
+			uint32_t       * nb_context          ,//[nb_front_end]
+			uint32_t         nb_general_register ,
+			uint32_t         nb_special_register ,
+                        Trat_scheme_t    rat_scheme          ,
+			uint32_t         nb_inst_insert      ,
+			uint32_t         nb_inst_retire      ,
+                        uint32_t      ** nb_branch_speculated,//[nb_front_end][nb_context]
+                        bool             is_toplevel=false
 			);
 //   public : Parameters  (Parameters & param) ;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/include/Register_Address_Translation_unit.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/include/Register_Address_Translation_unit.h	(revision 138)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/include/Register_Address_Translation_unit.h	(revision 139)
@@ -68,4 +68,6 @@
   public    : SC_IN (Tcontext_t        )   **  in_RENAME_FRONT_END_ID      ;//[nb_inst_insert]
   public    : SC_IN (Tcontext_t        )   **  in_RENAME_CONTEXT_ID        ;//[nb_inst_insert]
+  public    : SC_IN (Tdepth_t          )   **  in_RENAME_DEPTH             ;//[nb_inst_insert]
+  public    : SC_IN (Tcontrol_t        )   **  in_RENAME_SAVE_RAT          ;//[nb_inst_insert]
   public    : SC_IN (Tgeneral_address_t)   **  in_RENAME_NUM_REG_RA_LOG    ;//[nb_inst_insert]
   public    : SC_IN (Tgeneral_address_t)   **  in_RENAME_NUM_REG_RB_LOG    ;//[nb_inst_insert]
@@ -102,7 +104,5 @@
   public    : SC_IN (Tgeneral_address_t)   **  in_RETIRE_NUM_REG_RD_PHY_NEW;//[nb_inst_retire]
   public    : SC_IN (Tspecial_address_t)   **  in_RETIRE_NUM_REG_RE_PHY_NEW;//[nb_inst_retire]
-  public    : SC_OUT(Tcontrol_t        )   ** out_RETIRE_RESTORE_RD_PHY_OLD;//[nb_inst_retire]
-  public    : SC_OUT(Tcontrol_t        )   ** out_RETIRE_RESTORE_RE_PHY_OLD;//[nb_inst_retire]
-  public    : SC_OUT(Tcontrol_t        )   ** out_RETIRE_RESTORE           ;//[nb_inst_retire]
+  public    : SC_IN (Tcontrol_t        )   **  in_RETIRE_RESTORE           ;//[nb_inst_retire]
 
     // ~~~~~[ Interface "retire_event" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -110,31 +110,33 @@
   public    : SC_OUT(Tcontrol_t        )  *** out_RETIRE_EVENT_ACK            ;//[nb_front_end][nb_context]
   public    : SC_IN (Tevent_state_t    )  ***  in_RETIRE_EVENT_STATE          ;//[nb_front_end][nb_context]
+  public    : SC_IN (Tevent_type_t     )  ***  in_RETIRE_EVENT_TYPE           ;//[nb_front_end][nb_context]
+  public    : SC_IN (Tdepth_t          )  ***  in_RETIRE_EVENT_DEPTH          ;//[nb_front_end][nb_context]
 
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
 
     // ~~~~~[ Register ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
-  private   : Tgeneral_address_t          *** rat_gpr_not_speculative;      //[nb_front_end][nb_context][nb_general_register_logic]
-  private   : Tgeneral_address_t          *** rat_gpr_speculative;          //[nb_front_end][nb_context][nb_general_register_logic]
-  private   : bool                        *** rat_gpr_speculative_valid;    //[nb_front_end][nb_context][nb_general_register_logic]
-  private   : bool                        *** rat_gpr_update_table;         //[nb_front_end][nb_context][nb_general_register_logic]
-
-  private   : Tspecial_address_t          *** rat_spr_not_speculative;      //[nb_front_end][nb_context][nb_special_register_logic]
-  private   : Tspecial_address_t          *** rat_spr_speculative;          //[nb_front_end][nb_context][nb_special_register_logic]
-  private   : bool                        *** rat_spr_speculative_valid;    //[nb_front_end][nb_context][nb_special_register_logic]
-  private   : bool                        *** rat_spr_update_table;         //[nb_front_end][nb_context][nb_special_register_logic]
+  private   : Tgeneral_address_t          *** rat_gpr_not_speculative;      //[nb_front_end][nb_context]                      [nb_general_register_logic]
+  private   : Tgeneral_address_t          *** rat_gpr_speculative;          //[nb_front_end][nb_context]                      [nb_general_register_logic]
+  private   : bool                        *** rat_gpr_speculative_valid;    //[nb_front_end][nb_context]                      [nb_general_register_logic]
+  private   : Tgeneral_address_t         **** rat_gpr_save;                 //[nb_front_end][nb_context][nb_branch_speculated][nb_general_register_logic]
+
+  private   : Tspecial_address_t          *** rat_spr_not_speculative;      //[nb_front_end][nb_context]                      [nb_special_register_logic]
+  private   : Tspecial_address_t          *** rat_spr_speculative;          //[nb_front_end][nb_context]                      [nb_special_register_logic]
+  private   : bool                        *** rat_spr_speculative_valid;    //[nb_front_end][nb_context]                      [nb_special_register_logic]
+  private   : Tspecial_address_t         **** rat_spr_save;                 //[nb_front_end][nb_context][nb_branch_speculated][nb_special_register_logic]
+
+  private   : Tdepth_t                     ** rat_depth;                    //[nb_front_end][nb_context]
 
     // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   private   : Tcontrol_t                    * internal_RENAME_ACK;          //[nb_inst_insert]
+  private   : Tcontrol_t                    * internal_RENAME_SAVE;         //[nb_inst_insert]
   private   : Tcontrol_t                    * internal_INSERT_ACK;          //[nb_inst_insert]
   private   : Tcontrol_t                    * internal_RETIRE_ACK;          //[nb_inst_retire]
   private   : Tcontrol_t                   ** internal_RETIRE_EVENT_ACK    ;//[nb_front_end][nb_context]
 
-  private   : bool                        *** internal_rat_gpr_update_table;//[nb_front_end][nb_context][nb_general_register_logic]
-  private   : bool                        *** internal_rat_spr_update_table;//[nb_front_end][nb_context][nb_special_register_logic]
-
-  private   : Tcontrol_t                    * internal_RETIRE_RESTORE           ;//[nb_inst_retire]
-  private   : Tcontrol_t                    * internal_RETIRE_RESTORE_RD_PHY_OLD;//[nb_inst_retire]
-  private   : Tcontrol_t                    * internal_RETIRE_RESTORE_RE_PHY_OLD;//[nb_inst_retire]
-
+    // function pointer
+  public    : void (morpheo::behavioural::core::multi_ooo_engine::ooo_engine::rename_unit::register_translation_unit::register_address_translation_unit::Register_Address_Translation_unit::*function_constant       ) (void);
+  public    : void (morpheo::behavioural::core::multi_ooo_engine::ooo_engine::rename_unit::register_translation_unit::register_address_translation_unit::Register_Address_Translation_unit::*function_transition     ) (void);
+  public    : void (morpheo::behavioural::core::multi_ooo_engine::ooo_engine::rename_unit::register_translation_unit::register_address_translation_unit::Register_Address_Translation_unit::*function_genMealy_rename) (void);
 #endif
 
@@ -169,8 +171,19 @@
 					       
 #ifdef SYSTEMC				       
-  public  : void        constant                  (void);
-  public  : void        transition                (void);
-  public  : void        genMealy_rename           (void);
-  public  : void        genMealy_retire           (void);
+  public  : void        constant                            (void);
+  public  : void        transition                          (void);
+  public  : void        genMealy_rename                     (void);
+
+  // public  : void        function_no_save_constant           (void);
+  // public  : void        function_no_save_transition         (void);
+  // public  : void        function_no_save_genMealy_rename    (void);
+
+  public  : void        function_one_save_constant          (void);
+  public  : void        function_one_save_transition        (void);
+  public  : void        function_one_save_genMealy_rename   (void);
+
+  public  : void        function_depth_save_constant        (void);
+  public  : void        function_depth_save_transition      (void);
+  public  : void        function_depth_save_genMealy_rename (void);
 #endif					       
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/src/Parameters.cpp	(revision 138)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/src/Parameters.cpp	(revision 139)
@@ -20,20 +20,26 @@
 #undef  FUNCTION
 #define FUNCTION "Register_Address_Translation_unit::Parameters"
-  Parameters::Parameters (uint32_t   nb_front_end       ,
-			  uint32_t * nb_context         ,
-			  uint32_t   nb_general_register,
-			  uint32_t   nb_special_register,
-			  uint32_t   nb_inst_insert     ,
-			  uint32_t   nb_inst_retire     ,
-                          bool       is_toplevel)
+  Parameters::Parameters (uint32_t         nb_front_end        ,
+			  uint32_t       * nb_context          ,//[nb_front_end]
+			  uint32_t         nb_general_register ,
+			  uint32_t         nb_special_register ,
+                          Trat_scheme_t    rat_scheme          ,
+			  uint32_t         nb_inst_insert      ,
+			  uint32_t         nb_inst_retire      ,
+                          uint32_t      ** nb_branch_speculated,//[nb_front_end][nb_context]
+                          bool             is_toplevel)
   {
     log_printf(FUNC,Register_Address_Translation_unit,FUNCTION,"Begin");
 
-    _nb_front_end           = nb_front_end       ;
-    _nb_context             = nb_context         ;
-    _nb_general_register    = nb_general_register;
-    _nb_special_register    = nb_special_register;
-    _nb_inst_insert         = nb_inst_insert     ;
-    _nb_inst_retire         = nb_inst_retire     ;
+    _nb_front_end           = nb_front_end        ;
+    _nb_context             = nb_context          ;
+    _nb_general_register    = nb_general_register ;
+    _nb_special_register    = nb_special_register ;
+    _rat_scheme             = rat_scheme          ;
+    _nb_inst_insert         = nb_inst_insert      ;
+    _nb_inst_retire         = nb_inst_retire      ;
+    _nb_branch_speculated   = nb_branch_speculated;
+
+    _max_nb_context         = max<uint32_t>(_nb_context, _nb_front_end);
 
     test();
@@ -41,12 +47,14 @@
     if (is_toplevel)
       {
-        _size_front_end_id      = log2(nb_front_end       );
-        _size_context_id        = log2(max<uint32_t>(nb_context, nb_front_end));
-        _size_general_register  = log2(nb_general_register);
-        _size_special_register  = log2(nb_special_register);
+        _size_front_end_id      = log2(_nb_front_end       );
+        _size_context_id        = log2(_max_nb_context     );
+        _size_general_register  = log2(_nb_general_register);
+        _size_special_register  = log2(_nb_special_register);
+        _size_depth             = log2(max<uint32_t>(_nb_branch_speculated,_nb_front_end,_nb_context));
     
         _have_port_front_end_id = _size_front_end_id>0;
         _have_port_context_id   = _size_context_id  >0;
-        
+        _have_port_depth        = _size_depth       >0;
+
         copy();
       }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/src/Parameters_msg_error.cpp	(revision 138)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/src/Parameters_msg_error.cpp	(revision 139)
@@ -10,5 +10,5 @@
 #include <sstream>
 
-namespace morpheo                    {
+namespace morpheo {
 namespace behavioural {
 namespace core {
@@ -27,4 +27,18 @@
     Parameters_test test ("Register_Address_Translation_unit");
 
+    switch(_rat_scheme)
+      {
+      case RAT_NO_SAVE    :
+        {
+          test.error(toString(_("The Register Address Translation scheme \"%s\" is not yet implemented.\n"),toString(_rat_scheme).c_str()));
+        }
+      default             :
+      // case RAT_ONE_SAVE   :
+      // case RAT_DEPTH_SAVE :
+        {
+          break;
+        }
+      }
+
     return test;
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/src/Parameters_print.cpp	(revision 138)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/src/Parameters_print.cpp	(revision 139)
@@ -28,9 +28,10 @@
 
     xml.balise_open("register_address_translation_unit");
-    xml.singleton_begin("nb_front_end       "); xml.attribut("value",toString(_nb_front_end       )); xml.singleton_end();
-    xml.singleton_begin("nb_general_register"); xml.attribut("value",toString(_nb_general_register)); xml.singleton_end();
-    xml.singleton_begin("nb_special_register"); xml.attribut("value",toString(_nb_special_register)); xml.singleton_end();
-    xml.singleton_begin("nb_inst_insert     "); xml.attribut("value",toString(_nb_inst_insert     )); xml.singleton_end();
-    xml.singleton_begin("nb_inst_retire     "); xml.attribut("value",toString(_nb_inst_retire     )); xml.singleton_end();
+    xml.singleton_begin("nb_front_end        "); xml.attribut("value",toString(_nb_front_end       )); xml.singleton_end();
+    xml.singleton_begin("rat_scheme          "); xml.attribut("value",toString(_rat_scheme         )); xml.singleton_end();
+    xml.singleton_begin("nb_general_register "); xml.attribut("value",toString(_nb_general_register)); xml.singleton_end();
+    xml.singleton_begin("nb_special_register "); xml.attribut("value",toString(_nb_special_register)); xml.singleton_end();
+    xml.singleton_begin("nb_inst_insert      "); xml.attribut("value",toString(_nb_inst_insert     )); xml.singleton_end();
+    xml.singleton_begin("nb_inst_retire      "); xml.attribut("value",toString(_nb_inst_retire     )); xml.singleton_end();
 
     for (uint32_t i=0;i<_nb_front_end; i++)
@@ -40,5 +41,16 @@
 	xml.  attribut("id"  ,toString(i));
 	xml. balise_open_end();
-	xml.  singleton_begin("nb_context         "); xml.attribut("value",toString(_nb_context [i]     )); xml.singleton_end();
+	xml.  singleton_begin("nb_context          "); xml.attribut("value",toString(_nb_context [i]     )); xml.singleton_end();
+
+        for (uint32_t j=0;j<_nb_context[i]; j++)
+          {
+            xml. balise_open_begin("component");
+            xml.  attribut("type","context");
+            xml.  attribut("id"  ,toString(j));
+            xml. balise_open_end();
+            xml.  singleton_begin("nb_branch_speculated"); xml.attribut("value",toString(_nb_branch_speculated[i][j])); xml.singleton_end();
+            xml. balise_close();
+          }
+
 	xml. balise_close();
       }
